package com.geneoz.procedureengine;

import java.util.Collection;

import org.apache.log4j.Logger;
import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.definition.KnowledgePackage;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.junit.Test;

//@RunWith(SpringJUnit4ClassRunner.class)
//@ContextConfiguration(locations = { "classpath:applicationContext.xml",
//		"classpath:applicationContext-common-authorization.xml" })
//@TransactionConfiguration(transactionManager = "txManager", defaultRollback = true)
//@Transactional
public class JavaInteractiveTest {

	static Logger logger = Logger.getLogger(JavaInteractiveTest.class);

	/**
	 * @param args
	 */
	@Test
	public static void main(String[] args) {
//	public void test1() {
		logger.debug("This is a Good Drools test class.");
		logger.debug("Creting new KnowledgeBuilder");
		final KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();

		// this will parse and compile in one step
		kbuilder.add(ResourceFactory.newClassPathResource("com/geneoz/procedureengine/JavaInteractiveFlow.rf",
				JavaInteractiveTest.class), ResourceType.DRF);

		// Check the builder for errors
		if (kbuilder.hasErrors()) {
		    System.out.println(kbuilder.getErrors().toString());
		    throw new RuntimeException("Unable to compile \"JavaInteractiveFlow.rf\".");
		}

		// get the compiled packages (which are serializable)
		final Collection<KnowledgePackage> pkgs = kbuilder.getKnowledgePackages();

		logger.debug("Creting new KnowledgeBase");
		// add the packages to a knowledgebase (deploy the knowledge packages).
		final KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase();
		kbase.addKnowledgePackages(pkgs);

		logger.debug("Creting new KnowledgeSession");
		final StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();
		
		logger.debug("Executing session.");
		ksession.startProcess("interactiveJava");

		logger.debug("Finish execution.");
		
	}

}
